Swap(二分图的最大匹配)

Swap

HDU - 2819

Given an N*N matrix with each entry equal to 0 or 1. You can swap any two rows or any two columns. Can you find a way to make all the diagonal entries equal to 1?

InputThere are several test cases in the input. The first line of each test case is an integer N (1 <= N <= 100). Then N lines follow, each contains N numbers (0 or 1), separating by space, indicating the N*N matrix.OutputFor each test case, the first line contain the number of swaps M. Then M lines follow, whose format is “R a b” or “C a b”, indicating swapping the row a and row b, or swapping the column a and column b. (1 <= a, b <= N). Any correct answer will be accepted, but M should be more than 1000.

If it is impossible to make all the diagonal entries equal to 1, output only one one containing “-1”. 
Sample Input

2
0 1
1 0
2
1 0
1 0

Sample Output

1
R 1 2
-1题意:交换图的某些行或者是某些列,使得这个N*N的图对角线上全部都是1。题解:首先我们需要明白一个道理,如果通过交换某些行没有办法的到解的话,那么只交换列或者既交换行又交换列那也没办法得到解。为了解这道题,我们需要构造二分图,第一部分X表示的是横坐标,第二部分Y表示纵坐标,如果mp[i][j]==1.那我们就从X的i向Y的j引一条边,那么这条边的含义就可以解释为可以将Y的第j列(因为Y表示的是列的集合)移到第i列,使得a[i][i]变成1,这样就相当于是第i行第i列就变成了1,也就是说对角线多了一个1。这个地方一定要注意理解mp[i][j]的含义!!
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn=1100;
struct node{
    int st;
    int ed;
}e[maxn];
int used[maxn];
int a[maxn],b[maxn];
int match[maxn],mp[maxn][maxn];
int vis[maxn][maxn];
int x;
int n,cnt;
int dfs(int u)
{
    int i;

    for(i=1;i<=n;i++)
    {
        if(mp[u][i]&&!used[i])
        {
            used[i]=1;
            if(match[i]==-1||dfs(match[i]))
            {
                match[i]=u;
                return 1;
            }
        }
    }
    return 0;
}
int hungary()
{
    int ans=0,i;

    memset(match,-1,sizeof(match));
    for(i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        if(dfs(i))
            ans++;
    }
    return ans;
}
int main()
{
    while(~scanf("%d",&n))
    {
        memset(vis,0,sizeof(vis));
        memset(mp,0,sizeof(mp));
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                scanf("%d",&x);
                if(x==1)
                {
                    mp[i][j]=1;
                }
            }
        }
        int ans=hungary();

        if(ans<n)
            printf("-1\n");
        else
        {
            int cnt = 0, a[maxn]={0}, b[maxn]={0};
        for(int i=1; i<=n; i++)
        {
            while(i != match[i])
            {
                a[cnt] = i;
                b[cnt] = match[i];
                swap(match[i],  match[match[i]]);
                cnt ++;
            }
        }

        printf("%d\n", cnt);
        for(int i=0; i<cnt; i++)
            printf("C %d %d\n", a[i], b[i]);
        }

    }
}
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn=1100;
struct node{
    int st;
    int ed;
}e[maxn];
int used[maxn];
int a[maxn],b[maxn];
int match[maxn],mp[maxn][maxn];
int vis[maxn][maxn];
int x;
int n,cnt;

int dfs(int u)
{
    int i;

    for(i=1;i<=n;i++)
    {
        if(mp[u][i]&&!used[i])
        {
            used[i]=1;
            if(match[i]==-1||dfs(match[i]))
            {
                match[i]=u;
                return 1;
            }
        }
    }
    return 0;
}
int hungary()
{
    int ans=0,i;

    memset(match,-1,sizeof(match));
    for(i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        if(dfs(i))
            ans++;
    }
    return ans;
}
int main()
{
    while(~scanf("%d",&n))
    {
        memset(vis,0,sizeof(vis));
        memset(mp,0,sizeof(mp));
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                scanf("%d",&x);
                if(x==1)
                {
                    mp[j][i]=1;
                }
            }
        }
        int ans=hungary();

        if(ans<n)
            printf("-1\n");
        else
        {
            int cnt=0;
            memset(a,0,sizeof(a));
            memset(b,0,sizeof(b));
            for(int i=1;i<=n;i++)
            {
                while(i!=match[i])
                {
                    a[cnt]=i;
                    b[cnt]=match[i];
                    swap(match[i],match[match[i]]);
                    cnt++;
                }
            }
            printf("%d\n",cnt);
            for(int i=0;i<cnt;i++)
            {
                printf("R %d %d\n",a[i],b[i]);
            }
        }

    }
}
 

原文地址:https://www.cnblogs.com/1013star/p/9794769.html

时间: 2024-11-08 11:33:05

Swap(二分图的最大匹配)的相关文章

hdu3729 I&#39;m Telling the Truth (二分图的最大匹配)

http://acm.hdu.edu.cn/showproblem.php?pid=3729 I'm Telling the Truth Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1427    Accepted Submission(s): 719 Problem Description After this year’s col

(转)二分图的最大匹配、完美匹配和匈牙利算法

转载自http://www.renfei.org/blog/bipartite-matching.html 二分图的最大匹配.完美匹配和匈牙利算法 这篇文章讲无权二分图(unweighted bipartite graph)的最大匹配(maximum matching)和完美匹配(perfect matching),以及用于求解匹配的匈牙利算法(Hungarian Algorithm):不讲带权二分图的最佳匹配. 二分图:简单来说,如果图中点可以被分为两组,并且使得所有边都跨越组的边界,则这就是

二分图的最大匹配、完美匹配和匈牙利算法(转)

转载自:http://blog.csdn.net/pi9nc/article/details/11848327 二分图的最大匹配.完美匹配和匈牙利算法 这篇文章讲无权二分图(unweighted bipartite graph)的最大匹配(maximum matching)和完美匹配(perfect matching),以及用于求解匹配的匈牙利算法(Hungarian Algorithm):不讲带权二分图的最佳匹配. 二分图:简单来说,如果图中点可以被分为两组,并且使得所有边都跨越组的边界,则这

二分图与网络流 带权二分图的最大匹配

二分图与网络流  带权二分图的最大匹配 在某书上偶然发现,二分图和网络流是有联系的,在子图u中建立超级源点,在子图v中建立超级汇点,源点到u和汇点到v的每条边容量设为1,u和v中的边的容量也设为1,求出最大流也就是原二分图的最大匹配了. 而求带权二分图的最大匹配也就很容易了,将u和v的权值设为容量,仍然建立超级源点和超级汇点转为网络流解决即可. 真是一切皆可网络流啊...

hdu 2063 过山车(二分图匹配最大匹配数模板)

过山车 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 10776    Accepted Submission(s): 4748 Problem Description RPG girls今天和大家一起去游乐场玩,终于可以坐上梦寐以求的过山车了.可是,过山车的每一排只有两个座位,而且还有条不成文的规矩,就是每个女生必须找个个男生做par

HDU 2444 The Accomodation of Students 二分图判定+最大匹配

题目来源:HDU 2444 The Accomodation of Students 题意:n个人是否可以分成2组 每组的人不能相互认识 就是二分图判定 可以分成2组 每组选一个2个人认识可以去一个双人间 最多可以有几组 思路:二分图判定+最大匹配 #include <cstdio> #include <cstring> #include <vector> using namespace std; const int maxn = 550; int vis[maxn];

二分图匹配 最大匹配数+最大点覆盖 POJ 1469+POJ 3041

最大匹配数就等于最大点覆盖,因为在图里面,凡是要覆盖的点必定是连通的,而最大匹配之后,若还有点没有覆盖到,则必定有新的匹配,与最大匹配数矛盾,如果去掉一些匹配,则必定有点没有覆盖到. POJ 1469 比较简单,用的经典的二分图匹配算法. ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46

二分图的最大匹配:匈牙利算法

1. 二分图的匹配问题 1.1 二分图 简单来说,如果图中点可以被分为两组,并且使得所有边都跨越组的边界,则这就是一个二分图. 准确地说:把一个图的顶点划分为两个不相交集 U 和 V ,使得每一条边都分别连接U . V 中的顶点.如果存在这样的划分,则此图为一个二分图. 二分图的一个等价定义是:不含有「含奇数条边的环」的图.图 1 是一个二分图.为了清晰,我们以后都把它画成图 2 的形式. 1.2 匹配 在图论中,一个「匹配」(matching)是一个边的集合,其中任意两条边都没有公共顶点.例如

二分图的最大匹配 (匈牙利算法)再续

标签:二分图 最大匹配 最小集覆盖 匈牙利算法 1.二分图.最大匹配 什么是二分图:二分图又称作二部图,是图论中的一种特殊模型. 设G=(V,E)是一个无向图,如果顶点V可分割为两个互不相交的子集(A,B),并且图中的每条边(i,j)所关联的两个顶点i和j分别属于这两个不同的顶点集(i in A,j in B),则称图G为一个二分图. 什么是匹配:把上图想象成3男4女搞对象(无同性恋),连线代表彼此有好感,但最终只能1夫1妻,最终的配对结果连线就是一个匹配.匹配可以是空. 什么是最大匹配:在有好